;[]------------------------------------------------------------------------[]
;|                                                                          |
;| (c) 1993,1994 by Marc van Shaney , aka Kaya Memisoglu                    |
;|                                                                          |
;| Dieser Assembler-Source-Code unterliegt dem Urheberrecht von Kaya        |
;| Memisoglu und darf auch nur mit seiner schriftlichen Genehmigung         |
;| in kommerziellen Programmen verwendet werden.                            |
;| Ich bernehme keinerlei Verantwortung fr eventuelle Schden,die dieses  |
;| Programm verursacht.                                                     |
;|                                                                          |
;|                                                                          |
;| 18.12.1994 Kaya Memisoglu                                                |
;|                                                                          |
;[]------------------------------------------------------------------------[]
;
;[]------------------------------------------------------------------------[]
;|
;| This is the ASM-example for CDMI. It simply loads DEMO.MOD and starts
;| to play this module through the PC-Loudspeaker.
;|
;| You must link this module with CDMI.OBJ, EXT386.OBJ, SPEAKER.ASM,
;|  ADLIB.ASM, SBDMA.ASM and SBTIMER.ASM
;|


P386
LOCALS
JUMPS
.MODEL USE16 LARGE
STACK		200h			;512 bytes stack shopuld be enough


include ext386.inc
include cdmi.inc
include devices.inc
include keys.inc

;This macro shrinks the allocated memory to the size really needed by the
;program, because DOS allocates the WHOLE memory when loading an EXE prog.
;This naturally is not usable if you want to allocate some DOS-Heap.
;(This macro is from EXEPROG.ASM by Borland Inc.)
SHRINK_MEM MACRO
   MOV BX,SP
   ADD BX,15    ;convert SP into paragraphs
   SHR BX,4
   MOV AX,SS    ;calculate size of program using ES PSP address
   ADD BX,AX
   MOV AX,ES
   SUB BX,AX
   MOV AH,4AH   ;resize memory block with PSP
   INT 21H      ;address in ES
   ENDM

CRTC_Status       equ 3dah
Display_Enable    equ 01
Vertical_Sync     equ 08

WAIT_RETRACE MACRO
	LOCAL Nope3,Nope4
	mov dx,CRTC_Status
  Nope3:
	in al,dx
	test al,Display_Enable
	jnz short Nope3
  Nope4:
	in al,dx
	test al,Vertical_Sync
	jz short Nope4
	ENDM





.Code
Device_Ptr	dd	?
FName		db	"DEMO.MOD",0
Dev0		db	"Using Gravis Ultrasound driver.",13,10,'$'
Dev1		db	"Using SB-DMA driver.",13,10,'$'
Dev2		db	"Using SB-TIMER driver.",13,10,'$'
Dev3		db	"Using AdLib driver.",13,10,'$'
Dev4		db	"Using PC-Speaker driver.",13,10,'$'

PRINT MACRO a
	push ds
	mov ax,cs
	mov ds,ax
	mov dx,OFFSET a
	mov ah,9
	int 21h
	pop ds
      ENDM
main PROC FAR
	.STARTUP
	SHRINK_MEM
	mov eax,DISPLAY_INFO or EXIT_ON_LOWMEM or EXIT_ON_RESET or VERBOSE_PAUSE
	call Init_EXT386 C,4096,eax

	mov bx,SEG GUS_Driver
	mov es,bx
	mov ebx,es:[OFFSET GUS_Driver]		;Get GUS device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G0
	PRINT Dev0
	jmp @@1

@@G0:	mov bx,SEG SBDMA_Driver
	mov es,bx
	mov ebx,es:[OFFSET SBDMA_Driver]	;Get SBDMA device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G1
	PRINT Dev1
	jmp @@1

@@G1:	mov bx,SEG SBTIMER_Driver
	mov es,bx
	mov ebx,es:[OFFSET SBTIMER_Driver]	;Get SBTIMER device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G2
	PRINT Dev2
	jmp @@1

@@G2:	mov bx,SEG ADLIB_Driver
	mov es,bx
	mov ebx,es:[OFFSET ADLIB_Driver]	;Get AdLib device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G3
	PRINT Dev3
	jmp @@1

@@G3:	mov bx,SEG SPEAKER_Driver
	mov es,bx
	mov ebx,es:[OFFSET SPEAKER_Driver]	;Get PC-Speaker device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	PRINT Dev4

@@1:	mov ax,SEG CDMI_DMA_Address
	mov ds,ax
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_INIT]		;Init device (IMPORTANT !)
	call CDMI_Load_MOD C,OFFSET FName,cs
	cmp ax,0
	jl short ERROR
	call CDMI_Play_Song C,22000,CDMI_LOOP_FLAG,dword ptr cs:[Device_Ptr]

	mov ax,SEG CDMI_Poll_Counter
	mov ds,ax
	mov ds:[CDMI_poll_Counter],4
 @@2:   GETKEY
	test ax,ax
	jz @@2

	call CDMI_Stop_Song
	call CDMI_Free_Song
ERROR:	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_EXIT]		;DeInit device (IMPORTANT !)
	call Exit_EXT386
	.EXIT
main ENDP
END