/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*                   (c) 1993,1994 by Kaya Memisoglu                       */
/*                                    aka Marc van Shaney                  */
/*                                                                         */
/* Die kommerzielle Nutzung des Source-Codes ohne meine schriftliche       */
/* Genehmigung ist untersagt. Desweiteren hafte ich fr keinerlei          */
/* Schaden den das Programm verursacht.                                    */
/*                                                                         */
/* Geschrieben mit Borland C++ 3.1                                         */
/*     Borland C++ ist eingetragenes Warenzeichen der                      */
/*                                  Borland Inernational INC               */
/*                                                                         */
/*                                                                         */
/* 18.1.1994 - Kaya Memisoglu                                              */
/*                                                                         */
/***************************************************************************/



#include <dir.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>

#ifndef __COLOUR_PALETTE_TYPE
#define __COLOUR_PALETTE_TYPE

typedef struct {
		char R;
		char G;
		char B;
		char Alpha;
	       } Color;
typedef struct
	       {
		Color Colour[256];
	       } Palette;
#endif


#ifndef __FONT_TYPE
#define __FONT_TYPE
typedef struct {
		char Ident[4];
		char Name[32];
		int Type;
		int Size;
		int PixelWidth;
		int CharBytes;
		int ByteWidth;
		int ByteHeight;
		char Font[];
	       } Font_Header;
#endif

#ifndef BITMAP_TYPE
#define BITMAP_TYPE
typedef struct {
		int Width;
		int Height;
		int Bits_per_Pixel;
		int Bytes_per_Line;
		char Enhance[8];
		char Data[];
	       } Bitmap;
#endif

#ifndef __PCX_FORMAT
 #define __PCX_FORMAT

 #define DCX_Magic	       0x3ade68b1L
 #define SCR_Magic	       0x0cd
 #define PCX_Magic             10
 #define PCX_Coding            1
 #define PCX_Version           5
 #define PCX_Pal_Type          0
 #define PCX_Bitplanes         1



 typedef struct {
		char Magic;
		char Version;
		char Pack_Type;
		char Color_Depth;
		int X1,Y1,X2,Y2;
		int X_Resolution;
		int Y_Resolution;
		char EGA_Palette[48];
		char Reserved;
		char Bitplanes;
		int Bytes_per_Line;
		int Palette_Type;
		char Dummy[58];
	       } PCX_Header;
#endif


#ifndef __RIX_FORMAT
 #define __RIX_FORMAT
 #define RIX_Magic             0x33584952L   // RIX3
 typedef struct {
		 long Magic;
		 int X_Resolution;
		 int Y_Resolution;
		 char Reserved[2];
		 char Pal[768];
		} RIX_Header;
#endif



#define SAVE_PAL        	1
#define COMPRESS_PIC    	2
#define ONLY_PAL        	4
#define CONVERT_24to18  	16
#define SAVE_CMAP       	32
#define NO_PAL         	 	64
#define RESIZE			128
#define COMPRESS_FASTPIC        256
#define CONVERT_18to24		512

#define PCX_FILE		1
#define RIX_FILE		2
#define MAP_FILE		3
#define USE_PATCH		6
#define FON_FILE		7

#define DATA			1
#define CODE			2
#define FARDATA			3

#define FALSE			-1
#define TRUE                  	1
#define MAX_DATA		20


char PROCNAME[64]="",MODEL[12]="LARGE";
int SEGMENT=DATA,PROCDEFINE=0;
int FORMAT=0,OPTION=0;




void Convert_Pal(Palette *Pal)
{
 int i;
 if (OPTION & CONVERT_24to18)
       {
	for (i=0;i<256;i++)
	       {
		Pal->Colour[i].R>>=2;
		Pal->Colour[i].G>>=2;
		Pal->Colour[i].B>>=2;
	       }
       }

 if (OPTION & CONVERT_18to24)
       {
	for (i=0;i<256;i++)
	       {
		Pal->Colour[i].R<<=2;
		Pal->Colour[i].G<<=2;
		Pal->Colour[i].B<<=2;
	       }
       }
}




unsigned int Compress_RLE2(Bitmap *dest,Bitmap *src)
{
 int count,sign,line=0,row=0;
 unsigned int size=0;
 unsigned char *c=src->Data;
 signed char *d=dest->Data;

 dest->Height=src->Height;
 dest->Width=src->Width;

 while(line<dest->Height)
       {
	line++;
	count=0;
	sign=1;
	row=0;

	while (row<dest->Width)
	       {
		row++;
		if (*c++>127)
		       {
			if (sign==1)
			       {
				count++;
				if (count>127)
				       {
					*d++=127;
					count-=127;
					size++;
				       }
				}
			else
				{
				 if (count!=0)
				       {
					*d++=(signed char)count*sign;
					size++;
				       }
				 count=1;
				 sign=1;
				}
		       }
		else
		       {
			if (sign==-1)
			       {
				count++;
				if (count>127)
				       {
					*d++=-127;
					count-=127;
					size++;
				       }
				}
			else
				{
				 if (count!=0)
				       {
					*d++=(signed char)count*sign;
					size++;
				       }
				 count=1;
				 sign=-1;
				}
		       }
		}

	if (count!=0)
	       {
		*d++=(signed char)sign*count;
		size++;
	       }
       }

 return size;
}






unsigned int Compress_SKIP(Bitmap *dest,Bitmap *src)
{
 int sign,line=0,row=0;
 unsigned int size=0;
 unsigned char *c=src->Data;
 signed char *d=dest->Data;
 signed char *count=dest->Data;

 dest->Height=src->Height;
 dest->Width=src->Width;
 d++;

 while(line<dest->Height)
       {
	line++;
	*count=0;
	sign=1;
	row=0;

	while (row<dest->Width)
	       {
		row++;
		if (*c>0)
		       {
			if (sign==1)
			       {
				*d++=*c;
				*count+=1;
				size++;
				if (*count==127)
				       {
					count=d;
					*count=0;
					d++;
					size++;
				       }
				}
			else
				{
				 if (*count!=0)
				       {
					*count=-*count;
					count=d;
					d++;
					*d++=*c;
					size+=2;
				       }
				 *count=1;
				 sign=1;
				}
		       }
		else
		       {
			if (sign==-1)
			       {
				*count+=1;
				if (*count==127)
				       {
					*count=-127;
					count=d;
					*count=0;
					d++;
					size++;
				       }
				}
			else
				{
				 if (*count!=0)
				       {
					count=d;
					d++;
					size++;
				       }
				 *count=1;
				 sign=-1;
				}
		       }
		c++;
	       }

	if (*count!=0)
	       {
		*count=(signed char )*count*sign;
		count=d;
		d++;
		size++;
	       }
       }

 return size;
}




/**
 ** This is the Dr HALO RIX-Paint file format.
 ** Supported are only 256 colour images.
 **/
int Load_RIX_Picture(Bitmap *Tex,Palette *Pal,char *fname)
{
 char *Line=Tex->Data;
 int i,j;
 RIX_Header Rix;

 if((i=open(fname,O_RDONLY|O_BINARY))<1)
	return FALSE;
 _read(i,&Rix,sizeof(RIX_Header));

 if (Rix.Magic!=RIX_Magic)
       {
	close(i);
	return FALSE;
       }
 for (j=0;j<256;j++)
	{
	 Pal->Colour[j].R=Rix.Pal[j*3]<<2;
	 Pal->Colour[j].G=Rix.Pal[j*3+1]<<2;
	 Pal->Colour[j].B=Rix.Pal[j*3+2]<<2;
	}

 Tex->Bits_per_Pixel=8;
 Tex->Width=Rix.X_Resolution;
 Tex->Height=Rix.Y_Resolution;

 for (j=0;j<Rix.Y_Resolution;j++)
  {
   _read(i,Line,Rix.X_Resolution);
   Line+=Tex->Width;
  }

 close(i);
 return TRUE;
}




int Load_PCX_Picture(Bitmap *Tex,Palette *Pal,char *fname)
{
 char *ReadBuf;
 int i,h,wid,hei;
 long Size;
 PCX_Header PCX;

 if((h=open(fname,O_BINARY|O_RDWR))<1)
	return FALSE;
 lseek(h,0L,SEEK_END);
 Size=tell(h);
 lseek(h,0L,SEEK_SET);
 _read(h,&PCX,sizeof(PCX_Header));

 if (PCX.Magic!=PCX_Magic)
     {
      close(h);
      return FALSE;
     }

 wid=Tex->Width=PCX.X2-PCX.X1+1;
 hei=Tex->Height=PCX.Y2-PCX.Y1+1;
 Tex->Bits_per_Pixel=8;

 ReadBuf=(char far *)malloc(65000U);
 _read (h,ReadBuf,(unsigned int)(Size-768-sizeof(PCX_Header)));
 asm {
      push di
      push si
      push ds
      les di,Tex
      add di,16
      lds si,ReadBuf
      mov ax,wid
      mul hei
      mov dx,ax
      xor cx,cx
     }
 L1:
 asm {
	lodsb
	cmp al,192
	ja DoRLE
	stosb
	dec dx
	jnz L1
	jmp Ende
     }

 DoRLE:
 asm {
	mov cl,al
	lodsb
	and cl,63
	sub dx,cx
	pushf
	rep stosb
	popf
	jc Ende
	jnz L1
     }

 Ende:
 asm {
      pop ds
      pop si
      pop di

 }



 if (Tex->Bits_per_Pixel==8)				// 256 colour VGA-Picture
       {
	lseek(h,Size-768,SEEK_SET);
	for (i=0;i<256;i++)
		_read(h,&Pal->Colour[i],3);
       }
 close(h);

 free(ReadBuf);
 return TRUE;
}









void main(void)
{
 char INNAME[MAXPATH]="",OUTNAME[MAXPATH]="";
 int X0,X1,Y0,Y1,PATCH_START,PATCH_SIZE;


 if (_argc==1)
	   {
	    printf("\nBinary to Assmebler converter             (C)1995 by M. van Shaney of The Cross\n");
	    printf("bin2asm [InFile] {OutFile} +-options                 Compiling date:%s\n",__DATE__);
	    printf("Options:\n");
	    printf("  -mt TINY model                  +P  saves only the Palette\n");
	    printf("  -ms SMALL model                 -P  does not save a palette\n");
	    printf("  -mc COMPACT model               -C  makes FastSprite pictures\n");
	    printf("  -mm MEDIUM model                -c  makes a two-colour RLE\n");
	    printf("  -ml LARGE model                 -p[24to18/18to24] converts pal\n");
	    printf("  -n[name]  Procedure name        +c  uses codesegment\n");
	    printf("  +r  handles RIX files           +d  uses datasegment\n");
	    printf("  +m  handles colour8-map         +f  uses fardata segment\n");
	    printf("  +F  handles FONt-files          -R[start],[size]  saves only this position\n");
	    printf("  +p  handles PCX files\n");
	    printf("  -rx0,y0,x1,y1 For Pictures:Selects the part\n");
	    printf("if OutFile is not specified, it will be *.ASM\n\n");
	   }
 else
	   {
	    struct ffblk ffblk;
	    int done,i;
	    long pos,size;
	    char c;
	    char OutName[MAXPATH];
	    char UpStr[64];
	    FILE *In,*Out;
	    struct date Date;

	    getdate(&Date);
	    X0=-1;
	    PATCH_START=-1;

	    for (done=1;done<_argc;done++)
		  {
		   strcpy(UpStr,_argv[done]);
		   strupr(UpStr);
		   if (strstr(_argv[done],"-mt")!=NULL)
			 strcpy(MODEL,"TINY");
		   if (strstr(_argv[done],"-ms")!=NULL)
			 strcpy(MODEL,"SMALL");
		   if (strstr(_argv[done],"-mm")!=NULL)
			 strcpy(MODEL,"MEDIUM");
		   if (strstr(_argv[done],"-ml")!=NULL)
			 strcpy(MODEL,"LARGE");
		   if (strstr(_argv[done],"-mc")!=NULL)
			 strcpy(MODEL,"COMPACT");
		   if (strstr(_argv[done],"-n")!=NULL)
			{
			 strcpy(PROCNAME,_argv[done]+2);
			 PROCDEFINE=TRUE;
			}
		   if (strstr(_argv[done],"+P")!=NULL)
			 OPTION|=ONLY_PAL;
		   if (strstr(_argv[done],"-P")!=NULL)
			 OPTION|=NO_PAL;
		   if (strstr(_argv[done],"-c")!=NULL)
			 OPTION|=COMPRESS_PIC;
		   if (strstr(_argv[done],"-C")!=NULL)
			 OPTION|=COMPRESS_FASTPIC;
		   if (strstr(_argv[done],"-p18to24")!=NULL)
			 OPTION|=CONVERT_18to24;
		   if (strstr(_argv[done],"-p24to18")!=NULL)
			 OPTION|=CONVERT_24to18;

		   if (strstr(_argv[done],"+r")!=NULL)
			 FORMAT=RIX_FILE;
		   if (strstr(_argv[done],"+m")!=NULL)
			 FORMAT=MAP_FILE;
		   if (strstr(_argv[done],"+F")!=NULL)
			 FORMAT=FON_FILE;
		   if (strstr(_argv[done],"+p")!=NULL)
			 FORMAT=PCX_FILE;


		   if (strstr(_argv[done],"+d")!=NULL)
			 SEGMENT=DATA;
		   if (strstr(_argv[done],"+c")!=NULL)
			 SEGMENT=CODE;
		   if (strstr(_argv[done],"+f")!=NULL)
			 SEGMENT=FARDATA;

		   if (strstr(_argv[done],"-r")!=NULL)
			{
			 char buf[32],*c;
			 strcpy(buf,_argv[done]+2);
			 c=strchr(buf,',');
			 *c=0;
			 X0=atoi(buf);
			 strcpy(buf,c+1);
			 c=strchr(buf,',');
			 *c=0;
			 Y0=atoi(buf);
			 strcpy(buf,c+1);
			 c=strchr(buf,',');
			 *c=0;
			 X1=atoi(buf);
			 strcpy(buf,c+1);
			 Y1=atoi(buf);
			 OPTION|=RESIZE;
			}
		   if (strstr(_argv[done],"-R")!=NULL)
			{
			 char buf[32],*c;
			 strcpy(buf,_argv[done]+2);
			 c=strchr(buf,',');
			 *c=0;
			 PATCH_START=atoi(buf);
			 strcpy(buf,c+1);
			 PATCH_SIZE=atoi(buf);
			 FORMAT=USE_PATCH;
			}
		   if ((UpStr[0]!='-') && (UpStr[0]!='+'))
			{
			 if (strlen(INNAME)==0)
				strcpy(INNAME,UpStr);
			 else
				strcpy(OUTNAME,UpStr);
			}
		  }



	    printf("Converting: Modell:%s    Segment:",MODEL);
	    switch (SEGMENT)
			{
			 case CODE:
				printf("CODE\n");
				break;
			 case DATA:
				printf("DATA\n");
				break;
			 case FARDATA:
				printf("FARDATA\n");
				break;
			}
	    printf("Options in use:");
	    if (OPTION & COMPRESS_PIC)
		printf("COMPRESS  ");
	    if (OPTION & COMPRESS_FASTPIC)
		printf("fastpicCOMPRESS  ");
	    if (OPTION & ONLY_PAL)
		printf("onlyPAL  ");
	    if (OPTION & NO_PAL)
		printf("noPAL  ");
	    if (OPTION & RESIZE)
		printf("RESIZE  ");
	    done = findfirst(INNAME,&ffblk,0);
	    while (!done)
		  {
		   printf("\n");
		   if (OUTNAME[0]==0)
			   {
			    char *p;
			    strcpy(OutName,ffblk.ff_name);
			    if((p=strchr(OutName,'.'))==NULL)
				  p=OutName+strlen(OutName);
			    strcpy(p,".ASM");
			   }
		   else
			   {
			    strcpy(OutName,OUTNAME);
			   }
		   if (PROCDEFINE!=TRUE)
			   {
			    char *p;
			    strcpy(PROCNAME,OutName);
			    if((p=strchr(PROCNAME,'.'))==NULL)
				  p=PROCNAME+strlen(PROCNAME);
			    *p=0;
			   }


		   printf("  %s -> %s   PROCNAME:%s   ", ffblk.ff_name,OutName,PROCNAME);



		   if((In=fopen(ffblk.ff_name,"rb"))==NULL)
			  printf("\nError:%s not found !",ffblk.ff_name);
		   fseek(In,0L,SEEK_END);
		   size=ftell(In);
		   fseek(In,0L,SEEK_SET);
		   if((Out=fopen(OutName,"wt"))==NULL)
			  printf("\nError creating %s !",OutName);
		   fprintf(Out,";[]-------------------------------------------------------------------------[]\n");
		   fprintf(Out,";|                                                                           |\n");
		   fprintf(Out,";|   Assemblerfile created by bin2asm                                        |\n");
		   fprintf(Out,";|          bin2asm (C) 1994 by Marc van Shaney   &   Cyberdyne              |\n");
		   fprintf(Out,";|                                                                           |\n");
		   fprintf(Out,";|   Source   :%-59s   |\n",ffblk.ff_name);
		   fprintf(Out,";|   Proc-Name:%-59s   |\n",PROCNAME);
		   fprintf(Out,";|   Date     :%-2d/%-2d/%-4d                                                    |\n",Date.da_mon,Date.da_day,Date.da_year);
		   fprintf(Out,";|                                                                           |\n");
		   fprintf(Out,";[]-------------------------------------------------------------------------[]\n");
		   fprintf(Out,"\n\n\n\nP386\n");
		   fprintf(Out,".MODEL USE16 %s\n",MODEL);
		   switch (SEGMENT)
			{
			 case CODE:
				fprintf(Out,".CODE\n\n\n");
				break;
			 case DATA:
				fprintf(Out,".DATA\n\n\n");
				break;
			 case FARDATA:
				fprintf(Out,".FARDATA\n\n\n");
				break;
			}



		   if ((FORMAT==0) || (FORMAT==USE_PATCH))
			  {
			   i=10;
			   pos=0L;


			   if (FORMAT==USE_PATCH)
				{
				 printf("  Patch: %d -> %d (%d Bytes)",PATCH_START,PATCH_START+PATCH_SIZE,PATCH_SIZE);
				 fseek(In,PATCH_START,SEEK_SET);
				 size=PATCH_SIZE;
				}

			   fprintf(Out,"PUBLIC C %s\n",PROCNAME);
			   fprintf(Out,"%s DB",PROCNAME);
			   while(pos<=size)
				       {
					if (i==0)
					      fprintf(Out,"\nDB ");
					else
					      fprintf(Out,",");
					fread(&c,1,1,In);
					fprintf(Out,"%3d",(unsigned int)c);
					if((++i)>MAX_DATA)   i=0;
					pos++;
				       }
			   fprintf(Out,"\n\n\n\n");
			  }

		   if (FORMAT==MAP_FILE)
			  {
			   Palette Pal;
			   printf("Colour-MAP file  ");

			   fprintf(Out,";The following data is the palette with 3 bytes , one for each colour\n");
			   fprintf(Out,"PUBLIC C %s\n",PROCNAME);
			   fprintf(Out,"%s ",PROCNAME);
			   for (i=0;i<256;i++)
					fscanf(In,"%d%d%d",&Pal.Colour[i].R,&Pal.Colour[i].G,&Pal.Colour[i].B);
			   Convert_Pal(&Pal);
			   for (i=0;i<256;i++)
					fprintf(Out,"DB %3d,%3d,%3d\n",Pal.Colour[i].R,Pal.Colour[i].G,Pal.Colour[i].B);

			   fprintf(Out,"\n\n\n\n");
			  }



		   if (FORMAT==FON_FILE)
		       {
			Font_Header *Fon;
			int j;

			Fon=(Font_Header *)malloc((unsigned int)size);
			fread(Fon,(unsigned int)size,1,In);
			if (strcmp(Fon->Ident,"FON")!=NULL)
			       {
				printf("\nWrong font format !");
				break;
			       }
			printf("Fontfile found !\n");
			printf(" Font name :%s\n",Fon->Name);
			printf(" Font type :%d\n",Fon->Type);
			printf(" Font size :%dx%d\n",Fon->PixelWidth,Fon->ByteHeight);

			fprintf(Out,";This fon file is described by the following header:\n");
			fprintf(Out,";Offset	Size 	   Description\n");
			fprintf(Out,";\n");
			fprintf(Out,";0-3       4 bytes    Identification code (FON)\n");
			fprintf(Out,";4-35	32 bytes   Font name\n");
			fprintf(Out,";36-37     word       Font type\n");
			fprintf(Out,";38-39     word       Font version\n");
			fprintf(Out,";40-41     word       Font Width in pixels\n");
			fprintf(Out,";42-43     word       Bytes per character\n");
			fprintf(Out,";44-45     word       Font width in BYTES\n");
			fprintf(Out,";46-47     word       Font Height in lines\n");
			fprintf(Out,"PUBLIC C %s\n",PROCNAME);
			fprintf(Out,"%s ",PROCNAME);
			fprintf(Out,"DB \'FON\',0\n");
			fprintf(Out,"DB \'%-31s\',0\n",Fon->Name);
			fprintf(Out,"DW %d\n",Fon->Type);
			fprintf(Out,"DW %d\n",Fon->Size);
			fprintf(Out,"DW %d\n",Fon->PixelWidth);
			fprintf(Out,"DW %d\n",Fon->CharBytes);
			fprintf(Out,"DW %d\n",Fon->ByteWidth);
			fprintf(Out,"DW %d",Fon->ByteHeight);

			i=0;
			for (j=0;j<size-47;j++)
			       {
				if (i==0)
				      fprintf(Out,"\nDB ");
				else
				      fprintf(Out,",");
				fprintf(Out,"%3d",(unsigned int)Fon->Font[j]);
				if((++i)>MAX_DATA)   i=0;
			       }
			fprintf(Out,"\n\n\n");

		       }

		   if ((FORMAT==PCX_FILE) || (FORMAT==RIX_FILE))
		       {
			long j;
			Bitmap *Map;
			Palette Pal;

			fclose(In);
			Map=malloc(65000U);

			if (FORMAT==RIX_FILE)
				{
				printf("RIX-picture file    ");
				j=Load_RIX_Picture(Map,&Pal,ffblk.ff_name);
				}
			if (FORMAT==PCX_FILE)
				{
				printf("PCX-picture file    ");
				j=Load_PCX_Picture(Map,&Pal,ffblk.ff_name);
				}

			if (j<0)
				{
				 printf("\nError loading %s !",ffblk.ff_name);
				 break;
				}

			Convert_Pal(&Pal);

			if (!(OPTION & NO_PAL))
			       {
				fprintf(Out,";The following data is the palette with 3 bytes , one for each colour\n");
				fprintf(Out,"PUBLIC C %s_PAL\n",PROCNAME);
				fprintf(Out,"%s_PAL LABEL BYTE\n",PROCNAME);
				for (i=0;i<256;i++)
					fprintf(Out,"DB %3d,%3d,%3d\n",Pal.Colour[i].R,Pal.Colour[i].G,Pal.Colour[i].B);
				fprintf(Out,"\n\n\n\n");
			       }

			if (!(OPTION & ONLY_PAL))
			       {
				fprintf(Out,"; This is a bitmap file\n");
				fprintf(Out,"; But first comes a small header:\n");
				fprintf(Out,";    word  -  width\n");
				fprintf(Out,";    word  -  height\n");
				fprintf(Out,"; 12 bytes -  zero\n");

				fprintf(Out,"PUBLIC C %s_PIC\n",PROCNAME);
				fprintf(Out,"%s_PIC LABEL BYTE\n",PROCNAME);
				fprintf(Out,"dw %d,%d\n",Map->Width,Map->Height);
				fprintf(Out,"db 12 dup (0)\n");

				size=(long)Map->Width*(long)Map->Height;
				i=0;
				for (j=0;j<size;j++)
				       {
					if (i==0)
					      fprintf(Out,"\nDB ");
					else
					      fprintf(Out,",");
					fprintf(Out,"%3d",(unsigned int)Map->Data[j]);
					if((++i)>MAX_DATA)   i=0;
				       }
				fprintf(Out,"\n\n\n");
			       }
			free(Map);
		       }




		   fprintf(Out,"END\n");
		   fclose(Out);
		   fclose(In);


		   done = findnext(&ffblk);
		  }

	   }

}
